package cn.iocoder.yudao.module.mes.dal.redis.no;

import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateUtil;
import cn.iocoder.yudao.module.mes.dal.redis.RedisKeyConstants;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Repository;

import javax.annotation.Resource;
import java.time.Duration;
import java.time.LocalDateTime;


/**
 * Erp 订单序号的 Redis DAO
 *
 * @author HUIHUI
 */
@Repository
@Component
public class MesNoRedisDAO {


    /**
     * 模具 {@link cn.iocoder.yudao.module.common.dal.dataobject.mold.MoldDO}
     */
    public static final String MOLD_NO_PREFIX = "MUJU-";
    public static final String MOLD_RECORD_NO_PREFIX = "MR-";
    /**
     * 生产任务单{@link cn.iocoder.yudao.module.mes.dal.dataobject.task.TaskDO}
     */
    public static final String TASK_NO_PREFIX = "RWD-";
    /**
     * 生产计划 {@link cn.iocoder.yudao.module.mes.dal.dataobject.plan.PlanDO}
     */
    public static final String PLAN_NO_PREFIX = "JH-";
    /**
     * BOM {@link cn.iocoder.yudao.module.mes.dal.dataobject.bom.BomDO}
     */
    public static final String BOM_NO_PREFIX = "BOM-";
    /**
     * 领料单 {@link cn.iocoder.yudao.module.mes.dal.dataobject.bom.BomDO}
     */
    public static final String ITEM_REQUISITION_NO_PREFIX = "LL-";
    /**
     * 投料记录单
     */
    public static final String FEEDING_RECORD_CODE_PREFIX = "TL-";
    /**
     * 产线工位编码
     */
    public static final String ORG_WORKPLACE = "GW-";
    /**
     * 机台编码
     */
    public static final String ORG_MACHINE = "MA-";
    /**
     * 关键件编码
     */
    public static final String ORG_COMPONENT = "COM-";

    /**
     * 生产报工
     */
    public static final String REPORT_NO_PREFIX = "WR-";
    /**
     * 能源设备
     */
    public static final String ENERGY_NO_PREFIX = "EN-";

    @Resource
    private StringRedisTemplate stringRedisTemplate;

    /**
     * 生成序号，使用当前日期，格式为 {PREFIX} + yyyyMMdd + 6 位自增
     * 例如说：QTRK 202109 000001 （没有中间空格）
     *
     * @param prefix 前缀
     * @return 序号
     */
    public String generate6(String prefix) {
        // 递增序号
        String noPrefix = prefix + DateUtil.format(LocalDateTime.now(), DatePattern.PURE_DATE_PATTERN);
        String key = RedisKeyConstants.NO + noPrefix;
        Long no = stringRedisTemplate.opsForValue().increment(key);
        // 设置过期时间
        stringRedisTemplate.expire(key, Duration.ofDays(1L));
        return noPrefix + String.format("%06d", no);
    }

    public String generate3(String prefix) {
        // 递增序号
        String noPrefix = prefix + DateUtil.format(LocalDateTime.now(), DatePattern.PURE_DATE_PATTERN);
        String key = RedisKeyConstants.NO + noPrefix;
        Long no = stringRedisTemplate.opsForValue().increment(key);
        // 设置过期时间
        stringRedisTemplate.expire(key, Duration.ofDays(1L));
        return noPrefix + String.format("%03d", no);
    }

    public String generate2(String prefix) {
        // 递增序号
        String noPrefix = prefix + DateUtil.format(LocalDateTime.now(), DatePattern.PURE_DATE_PATTERN);
        String key = RedisKeyConstants.NO + noPrefix;
        Long no = stringRedisTemplate.opsForValue().increment(key);
        // 设置过期时间
        stringRedisTemplate.expire(key, Duration.ofDays(1L));
        return noPrefix + String.format("%02d", no);
    }

    public String generate(String prefix) {
        // 递增序号
        String noPrefix = prefix + DateUtil.format(LocalDateTime.now(), DatePattern.PURE_DATE_PATTERN);
        String key = RedisKeyConstants.NO + noPrefix;
        Long no = stringRedisTemplate.opsForValue().increment(key);
        // 设置过期时间
        stringRedisTemplate.expire(key, Duration.ofDays(1L));
        return noPrefix + String.format("%02d", no);
    }
}
